#ifndef _H_613E95AE298CE42D868B46C521985438_PedestrianImageID_DCPS_H_
#define _H_613E95AE298CE42D868B46C521985438_PedestrianImageID_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PedestrianImageID_.h"


namespace marti_perception_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PedestrianImageID_TypeSupportInterface;

            typedef PedestrianImageID_TypeSupportInterface * PedestrianImageID_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PedestrianImageID_TypeSupportInterface> PedestrianImageID_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PedestrianImageID_TypeSupportInterface> PedestrianImageID_TypeSupportInterface_out;


            class PedestrianImageID_DataWriter;

            typedef PedestrianImageID_DataWriter * PedestrianImageID_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PedestrianImageID_DataWriter> PedestrianImageID_DataWriter_var;
            typedef DDS_DCPSInterface_out < PedestrianImageID_DataWriter> PedestrianImageID_DataWriter_out;


            class PedestrianImageID_DataReader;

            typedef PedestrianImageID_DataReader * PedestrianImageID_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PedestrianImageID_DataReader> PedestrianImageID_DataReader_var;
            typedef DDS_DCPSInterface_out < PedestrianImageID_DataReader> PedestrianImageID_DataReader_out;


            class PedestrianImageID_DataReaderView;

            typedef PedestrianImageID_DataReaderView * PedestrianImageID_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PedestrianImageID_DataReaderView> PedestrianImageID_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PedestrianImageID_DataReaderView> PedestrianImageID_DataReaderView_out;

            struct PedestrianImageID_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PedestrianImageID_, struct PedestrianImageID_Seq_uniq_> PedestrianImageID_Seq;
            typedef DDS_DCPSSequence_var < PedestrianImageID_Seq> PedestrianImageID_Seq_var;
            typedef DDS_DCPSSequence_out < PedestrianImageID_Seq> PedestrianImageID_Seq_out;

            class  PedestrianImageID_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PedestrianImageID_TypeSupportInterface_ptr _ptr_type;
                typedef PedestrianImageID_TypeSupportInterface_var _var_type;

                static PedestrianImageID_TypeSupportInterface_ptr _duplicate (PedestrianImageID_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PedestrianImageID_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PedestrianImageID_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PedestrianImageID_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PedestrianImageID_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PedestrianImageID_TypeSupportInterface () {};
                ~PedestrianImageID_TypeSupportInterface () {};
            private:
                PedestrianImageID_TypeSupportInterface (const PedestrianImageID_TypeSupportInterface &);
                PedestrianImageID_TypeSupportInterface & operator = (const PedestrianImageID_TypeSupportInterface &);
            };

            class  PedestrianImageID_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PedestrianImageID_DataWriter_ptr _ptr_type;
                typedef PedestrianImageID_DataWriter_var _var_type;

                static PedestrianImageID_DataWriter_ptr _duplicate (PedestrianImageID_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PedestrianImageID_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PedestrianImageID_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PedestrianImageID_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PedestrianImageID_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PedestrianImageID_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PedestrianImageID_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PedestrianImageID_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PedestrianImageID_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PedestrianImageID_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PedestrianImageID_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PedestrianImageID_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PedestrianImageID_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PedestrianImageID_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PedestrianImageID_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PedestrianImageID_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PedestrianImageID_& instance_data) = 0;

            protected:
                PedestrianImageID_DataWriter () {};
                ~PedestrianImageID_DataWriter () {};
            private:
                PedestrianImageID_DataWriter (const PedestrianImageID_DataWriter &);
                PedestrianImageID_DataWriter & operator = (const PedestrianImageID_DataWriter &);
            };

            class  PedestrianImageID_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PedestrianImageID_DataReader_ptr _ptr_type;
                typedef PedestrianImageID_DataReader_var _var_type;

                static PedestrianImageID_DataReader_ptr _duplicate (PedestrianImageID_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PedestrianImageID_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PedestrianImageID_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PedestrianImageID_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PedestrianImageID_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PedestrianImageID_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PedestrianImageID_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PedestrianImageID_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PedestrianImageID_& instance) = 0;

            protected:
                PedestrianImageID_DataReader () {};
                ~PedestrianImageID_DataReader () {};
            private:
                PedestrianImageID_DataReader (const PedestrianImageID_DataReader &);
                PedestrianImageID_DataReader & operator = (const PedestrianImageID_DataReader &);
            };

            class  PedestrianImageID_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PedestrianImageID_DataReaderView_ptr _ptr_type;
                typedef PedestrianImageID_DataReaderView_var _var_type;

                static PedestrianImageID_DataReaderView_ptr _duplicate (PedestrianImageID_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PedestrianImageID_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PedestrianImageID_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PedestrianImageID_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PedestrianImageID_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PedestrianImageID_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PedestrianImageID_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PedestrianImageID_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PedestrianImageID_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PedestrianImageID_& instance) = 0;

            protected:
                PedestrianImageID_DataReaderView () {};
                ~PedestrianImageID_DataReaderView () {};
            private:
                PedestrianImageID_DataReaderView (const PedestrianImageID_DataReaderView &);
                PedestrianImageID_DataReaderView & operator = (const PedestrianImageID_DataReaderView &);
            };
        }

    }

}

#endif
